## ros-noetic-navfn 1.17.3

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0.2)
project(navfn)

include(CheckIncludeFile)

find_package(catkin REQUIRED
    COMPONENTS
        cmake_modules
        costmap_2d
        geometry_msgs
        message_generation
        nav_core
        nav_msgs
        pluginlib
        rosconsole
        roscpp
        tf2_ros
        sensor_msgs
        visualization_msgs
        )

find_package(Eigen3 REQUIRED)
include_directories(
    include
    ${catkin_INCLUDE_DIRS}
    ${EIGEN3_INCLUDE_DIRS}
)
add_definitions(${EIGEN3_DEFINITIONS})


# services
add_service_files(
    DIRECTORY srv
    FILES
    MakeNavPlan.srv
    SetCostmap.srv
)

generate_messages(
    DEPENDENCIES
        geometry_msgs
)

catkin_package(
    INCLUDE_DIRS
        include
    LIBRARIES
        navfn
    CATKIN_DEPENDS
        geometry_msgs
        message_runtime
        nav_core
        nav_msgs
        pluginlib
        roscpp
        sensor_msgs
        visualization_msgs
)

check_include_file(sys/time.h HAVE_SYS_TIME_H)
if (HAVE_SYS_TIME_H)
  add_definitions(-DHAVE_SYS_TIME_H)
endif (HAVE_SYS_TIME_H)

add_library (navfn src/navfn.cpp src/navfn_ros.cpp)
target_link_libraries(navfn
    ${catkin_LIBRARIES}
    )
add_dependencies(navfn ${PROJECT_NAME}_generate_messages_cpp ${catkin_EXPORTED_TARGETS})

add_executable(navfn_node src/navfn_node.cpp)
target_link_libraries(navfn_node
    navfn
    )

install(TARGETS navfn_node
       RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
       )

install(TARGETS navfn
       ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
       LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
       RUNTIME DESTINATION ${CATKIN_GLOBAL_BIN_DESTINATION}
       )

install(DIRECTORY include/navfn/
    DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
)

install(FILES bgp_plugin.xml
    DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
)

### The problem with FindFLTK is that it only reports success if *all*
### fltk components are installed, but we only need the core library.
# include (FindFLTK)
include (CheckIncludeFileCXX)
check_include_file_cxx (FL/Fl.H NAVFN_HAVE_FLTK)
check_include_file_cxx (pgm.h NAVFN_HAVE_NETPBM)
message (STATUS "NAVFN_HAVE_FLTK: ${NAVFN_HAVE_FLTK}, NETPBM: ${NAVFN_HAVE_NETPBM}")
# Just linking -lfltk is not sufficient on OS X
if (NAVFN_HAVE_FLTK AND NAVFN_HAVE_NETPBM AND NOT APPLE)
  message (STATUS "FLTK found: adding navtest to build")
  add_executable (navtest src/navtest/navtest.cpp src/navtest/navwin.cpp)
  set (FLTK_SKIP_FLUID 1)
  set (FLTK_SKIP_FORMS 1)
  set (FLTK_SKIP_IMAGES 1)
  find_package(FLTK)
  if(FLTK_FOUND)
    target_link_libraries (navtest navfn netpbm ${FLTK_LIBRARIES})
  else (FLTK_FOUND)
    target_link_libraries (navtest navfn netpbm fltk)
  endif (FLTK_FOUND)
else (NAVFN_HAVE_FLTK)
  message (STATUS "FLTK orf NETPBM not found: cannot build navtest")
endif (NAVFN_HAVE_FLTK AND NAVFN_HAVE_NETPBM AND NOT APPLE)

### For some reason (on cmake-2.4.7 at least) the "check" for pgm.h
### always succeeds, even if pgm.h is not installed. It seems to be
### caused by a bug in the rule that attempts to build the C source:
### instead of directly calling e.g. 'gcc -c
### /CMakeFiles/CMakeTmp/CheckIncludeFile.c' it goes through some make
### infrastructure, which reports "Nothing to be done for
### `CMakeFiles/cmTryCompileExec.dir/build'" and calls that a success.
###
### As a workaround we simply force everyone to install libnetpbm
#
# include (CheckIncludeFile)
# check_include_file (pgm.h NAVFN_HAVE_NETPBM)
# message (STATUS "NAVFN_HAVE_NETPBM: ${NAVFN_HAVE_NETPBM}")
# if (NAVFN_HAVE_NETPBM)
#   message (STATUS "found pgm.h")
#   add_definitions (-DNAVFN_HAVE_NETPBM)
#target_link_libraries (navfn -lnetpbm)
# else (NAVFN_HAVE_NETPBM)
#   message (STATUS "pgm.h not found (optional)")
# endif (NAVFN_HAVE_NETPBM)

if(CATKIN_ENABLE_TESTING)
  add_subdirectory(test)
endif()

=== debian/changelog ===
ros-noetic-navfn (1.17.3-1focal) focal; urgency=high

  * [ROS-O] various patches (#1225 <https://github.com/ros-planning/navigation/issues/1225>)
    * do not specify obsolete c++11 standard
    this breaks with current versions of log4cxx.
    * update pluginlib include paths
    the non-hpp headers have been deprecated since kinetic
    * use lambdas in favor of boost::bind
    Using boost's _1 as a global system is deprecated since C++11.
    The ROS packages in Debian removed the implicit support for the global symbols,
    so this code fails to compile there without the patch.
  * Contributors: Michael Görner

 -- David V. Lu!! <davidvlu@gmail.com>  Tue, 10 Jan 2023 05:00:00 -0000

ros-noetic-navfn (1.17.2-1focal) focal; urgency=high

  * navfn: stop installing test headers (#1085 <https://github.com/ros-planning/navigation/issues/1085>)
    The navtest executable is only built if FLTK is installed. However, the
    header it uses is installed regardless, and requires FLTK. Nothing else
    uses this header, and navfn doesn't depend upon FLTK, so stop installing
    the header. Also fix navtest to actually build when FLTK is installed.
  * Contributors: Kyle Fazzari

 -- David V. Lu!! <davidvlu@gmail.com>  Mon, 20 Jun 2022 04:00:00 -0000

ros-noetic-navfn (1.17.1-1focal) focal; urgency=high



 -- David V. Lu!! <davidvlu@gmail.com>  Thu, 27 Aug 2020 04:00:00 -0000

ros-noetic-navfn (1.17.0-1focal) focal; urgency=high

  * Merge pull request #982 <https://github.com/ros-planning/navigation/issues/982> from ros-planning/noetic_prep
    Noetic Migration
  * increase required cmake version
  * Contributors: Michael Ferguson

 -- David V. Lu!! <davidvlu@gmail.com>  Thu, 02 Apr 2020 04:00:00 -0000

ros-noetic-navfn (1.16.6-1focal) focal; urgency=high

  * Fix Unknown CMake command check_include_file (navfn & base_local_planner) (#975 <https://github.com/ros-planning/navigation/issues/975>)
  * Contributors: Sam Pfeiffer

 -- David V. Lu!! <davidvlu@gmail.com>  Wed, 18 Mar 2020 04:00:00 -0000

ros-noetic-navfn (1.16.5-1focal) focal; urgency=high

  * [melodic] updated install for better portability. (#973 <https://github.com/ros-planning/navigation/issues/973>)
  * Contributors: Sean Yen

 -- David V. Lu!! <davidvlu@gmail.com>  Sun, 15 Mar 2020 04:00:00 -0000

ros-noetic-navfn (1.16.4-1focal) focal; urgency=high

  * [Windows][melodic] Navigation (except for map_server and amcl) Windows build bring up (#851 <https://github.com/cobalt-robotics/navigation/issues/851>)
  * Add frame ID to empty NavFn paths (#964 <https://github.com/cobalt-robotics/navigation/issues/964>)
    * Don't publish empty paths
    RViz will complain about not being able to transform the path if it doesn't have a frame ID, so we'll just drop these
    Closes #963 <https://github.com/cobalt-robotics/navigation/issues/963>
    * Publish empty paths with a valid frame
    * Fix indexing into empty plan for timestamp
  * Contributors: Nick Walker, Sean Yen

 -- David V. Lu!! <davidvlu@gmail.com>  Wed, 04 Mar 2020 05:00:00 -0000

ros-noetic-navfn (1.16.3-1focal) focal; urgency=high

  * Merge pull request #831 <https://github.com/ros-planning/navigation/issues/831> from ros-planning/feature/remove_slashes
    [melodic] Remove leading slashes from default frame_id parameters
  * Remove leading slashes from default frame_id parameters
  * Merge pull request #789 <https://github.com/ros-planning/navigation/issues/789> from ipa-fez/fix/astar_const_melodic
    Remove const from create_nav_plan_astar
  * remove const from create_nav_plan_astar
  * Contributors: David V. Lu, Felix, Michael Ferguson

 -- David V. Lu!! <davidvlu@gmail.com>  Fri, 15 Nov 2019 05:00:00 -0000

ros-noetic-navfn (1.16.2-1focal) focal; urgency=high



 -- David V. Lu!! <davidvlu@gmail.com>  Tue, 31 Jul 2018 04:00:00 -0000

ros-noetic-navfn (1.16.1-1focal) focal; urgency=high



 -- David V. Lu!! <davidvlu@gmail.com>  Sat, 28 Jul 2018 04:00:00 -0000

ros-noetic-navfn (1.16.0-1focal) focal; urgency=high

  * Remove dependency on PCL
  * Switch to TF2 #755 <https://github.com/ros-planning/navigation/issues/755>
  * Merge pull request #737 <https://github.com/ros-planning/navigation/issues/737> from marting87/minor_comment_fixes
    Minor comment corrections
  * Contributors: David V. Lu, Martin Ganeff, Michael Ferguson, Vincent Rabaud

 -- David V. Lu!! <davidvlu@gmail.com>  Wed, 25 Jul 2018 04:00:00 -0000

ros-noetic-navfn (1.15.2-1focal) focal; urgency=high

  * Merge pull request #673 <https://github.com/ros-planning/navigation/issues/673> from ros-planning/email_update_lunar
    update maintainer email (lunar)
  * Remove Dead Code [Lunar] (#646 <https://github.com/ros-planning/navigation/issues/646>)
    * Clean up navfn
    * Cleanup amcl
  * Merge pull request #649 <https://github.com/ros-planning/navigation/issues/649> from aaronhoy/lunar_add_ahoy
    Add myself as a maintainer.
  * Rebase PRs from Indigo/Kinetic (#637 <https://github.com/ros-planning/navigation/issues/637>)
    * Respect planner_frequency intended behavior (#622 <https://github.com/ros-planning/navigation/issues/622>)
    * Only do a getRobotPose when no start pose is given (#628 <https://github.com/ros-planning/navigation/issues/628>)
    Omit the unnecessary call to getRobotPose when the start pose was
    already given, so that move_base can also generate a path in
    situations where getRobotPose would fail.
    This is actually to work around an issue of getRobotPose randomly
    failing.
    * Update gradient_path.cpp (#576 <https://github.com/ros-planning/navigation/issues/576>)
    * Update gradient_path.cpp
    * Update navfn.cpp
    * update to use non deprecated pluginlib macro (#630 <https://github.com/ros-planning/navigation/issues/630>)
    * update to use non deprecated pluginlib macro
    * multiline version as well
    * Print SDL error on IMG_Load failure in server_map (#631 <https://github.com/ros-planning/navigation/issues/631>)


=== debian/control ===
Source: ros-noetic-navfn
Section: misc
Priority: optional
Maintainer: David V. Lu!! <davidvlu@gmail.com>
Build-Depends: debhelper (>= 9.0.0), libnetpbm10-dev, ros-noetic-catkin (>= 0.5.68), ros-noetic-cmake-modules, ros-noetic-costmap-2d, ros-noetic-geometry-msgs, ros-noetic-message-generation, ros-noetic-nav-core, ros-noetic-nav-msgs, ros-noetic-pluginlib, ros-noetic-rosconsole, ros-noetic-roscpp, ros-noetic-rosunit <!nocheck>, ros-noetic-sensor-msgs, ros-noetic-tf2-ros, ros-noetic-visualization-msgs
Homepage: http://wiki.ros.org/navfn
Standards-Version: 3.9.2

Package: ros-noetic-navfn
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-noetic-costmap-2d, ros-noetic-geometry-msgs, ros-noetic-message-runtime, ros-noetic-nav-core, ros-noetic-nav-msgs, ros-noetic-pluginlib, ros-noetic-rosconsole, ros-noetic-roscpp, ros-noetic-sensor-msgs, ros-noetic-tf2-ros, ros-noetic-visualization-msgs
Description: navfn provides a fast interpolated navigation function that can be used to create plans for a mobile base.
 The planner assumes a circular robot and operates on a costmap to find a minimum cost plan from a start point to an end point in a grid. The navigation function is computed with Dijkstra's algorithm, but support for an A* heuristic may also be added in the near future. navfn also provides a ROS wrapper for the navfn planner that adheres to the nav_core::BaseGlobalPlanner interface specified in nav_core.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/noetic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF -DCATKIN_ENABLE_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/noetic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/noetic" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-noetic-navfn//opt/ros/noetic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_install
